/*  Horloge parlante synchronisée sur réseau Wifi.
 *         Avec afficheur TM1637 
 *         
 * Convient aux horloges non parlantes. la partie
 * vocale n'est alors pas prise en compte.
 *         
 *  Complétez le programme avec le nom de
 *  votre réseau et son mot de passe.
 *  La luminosité de l'afficheur peut-être ajustée
 *  dans le programme. (De 0 à 7).
 *
 *    #define CLK 2     // D9
 *    #define DIO 4     // D4
 *    int Parlant = 16; // D2   Platine WeMos D1: Poussoir Parle connecté D2 (+ ou - 5V)
 *    SoftwareSerial mySerial(12, 13); //  D6, D7  RX, TX,
 *
 *
 *  Version 6   12/2018.
 *  Version 7   04/2019.
 *
 *  http://f5mna.free.fr
 *
 */

/////////////////Parlante
#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>
SoftwareSerial mySerial(13, 12); // RX, TX
//////////////////////////////////////////////////
#include <ESP8266WiFi.h>
#include <time.h>
#include <Wire.h>
#include "TM1637.h"
#define CLK 2   // D9
#define DIO 4   // D4

//int EteHiver = 12; // Inverseur changement d'heure été/hiver  ((D12 du Wemos D1))
int EteHiver = 5; // Version parlante ((D3 du Wemos D1))

int8_t TimeDisp[] = {0x00, 0x00, 0x00, 0x00};
TM1637 tm1637(CLK, DIO);

int Heure, HeureDiz, HeureUnit, MinutDiz, MinutUnit, i, Minutes, JourDiz, timezone,E_Hiver;
int Parlant = 16; // Platine WeMos D1: Poussoir Saison connecté D2 (+ ou - 5V)
int ValParle = 0;
String Dizheure, Dizheure1, Unitheure, Unitheure1, DizMinute, UnitMinute, Jour;

/////////////////////////////////////////////////
const char* ssid = "NomdeVotreBox";      // A Modifier  selon votre box.
const char* password = "SonMotdePasse";  // A modifier (votre mot de passe).


void setup() {
  mySerial.begin(9600);
  delay(400);  
  mp3_set_serial (mySerial); // programme serie pour module DFPlayer-mini mp3
  delay(400);
  
  mp3_set_volume (25); //  Volume de 0 à 30
  delay(400);
  /////////
  Serial.begin(9600);
  pinMode (Parlant, INPUT);
  pinMode (EteHiver, INPUT);

  tm1637.set();
  tm1637.set(0); //BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7; //// Luminosité de l'afficheur
  tm1637.init();

  tm1637.display(0, 8) ;
  tm1637.display(1, 8);
  tm1637.display(2, 8);
  tm1637.display(3, 8);

  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  Serial.println(" Non connecte WiFi");
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(1000);
  }
  configTime(1 * 3600, 0, "pool.ntp.org", "time.nist.gov");
}

String Divisetexte(String data, char separator, int index)
{
  int stringData = 0;
  String dataPart = "";

  for (int i = 0; i < data.length() - 1; i++) { // Un passage pour analyser le texte
    if (data[i] == separator) {// Compte le nombre de caractères de séparation du texte
      stringData++;

    } else if (stringData == index) { //Prend en compte le texte quand le séparateur est présent
      dataPart.concat(data[i]); // Ajout de chaque données entre séparateur


    } else if (stringData > index) {
      return dataPart;
      break;
    }
  }
  return dataPart;
}

void loop() {
  
 E_Hiver = digitalRead(EteHiver);   // lecture de la touche
 if (E_Hiver == HIGH) timezone = 2; // Ete
 if (E_Hiver == LOW) timezone = 1;  // Hiver  
 configTime(timezone * 3600, 0, "pool.ntp.org", "time.nist.gov");
 
  while (WiFi.status() != WL_CONNECTED) {
    tm1637.display(0, 8) ;
    tm1637.display(1, 8);
    tm1637.point(POINT_ON);
    tm1637.display(2, 8);
    tm1637.display(3, 8);
  }

  time_t now = time(nullptr);
  String Temps = (ctime(&now));
  Serial.println (Temps);

  Serial.print ("1:  ");
  Serial.print ((Divisetexte(Temps, ' ', 3)).substring(0, 1)); //Heures
  Serial.println ((Divisetexte(Temps, ' ', 3)).substring(2, 1)); //Heures
  Serial.print ("2:  ");
  Serial.print ((Divisetexte(Temps, ':', 1)).substring(0, 1)); // Minutes
  Serial.println ((Divisetexte(Temps, ':', 1)).substring(2, 1)); // Minutes
  Jour = ((Divisetexte(Temps, ' ',2)).substring(0,1)); // Dizaine jours
  
  JourDiz = (Jour.toInt());   //Passage string à int
 //  Serial.print ("DizJour ");  
 // Serial.println (JourDiz);  
  Dizheure  = ((Divisetexte(Temps, ' ',4)).substring(0,1)); // dizaines d'heures
  if (JourDiz > 0 ) (Dizheure = ((Divisetexte(Temps, ' ',3)).substring(0,1))); // dizaines d'heures
  Dizheure1 = ((Divisetexte(Temps, ' ',4)).substring(2,1)); //Heures
  if (JourDiz > 0) (Dizheure1 = ((Divisetexte(Temps, ' ',3)).substring(2,1))); //Heures


  Unitheure = ((Divisetexte(Temps, ':', 1)).substring(0, 1)); // unités heures
  Unitheure1 = ((Divisetexte(Temps, ':', 1)).substring(2, 1)); // unités heures

  Serial.print ("Dizheure  ");
  Serial.println (Dizheure);
  Serial.print ("Dizheure1  ");
  Serial.println (Dizheure1);
  Serial.print ("Unitheure   ");
  Serial.println (Unitheure);
  Serial.print ("Unitheure1   ");
  Serial.println (Unitheure1);
  Serial.println();

  HeureDiz = (Dizheure.toInt());   //Passage string à int
  HeureUnit = (Dizheure1.toInt());
  MinutDiz = (Unitheure.toInt());
  MinutUnit  = (Unitheure1.toInt());

  
Heure = ((HeureDiz* 10) + HeureUnit); 
if ((HeureDiz != 0) && (HeureUnit != 0) or  (HeureUnit != 1) ){
HeureDiz = Heure/10;
HeureUnit = Heure - (HeureDiz*10);
} 

  Minutes = (MinutDiz * 10) + MinutUnit; 

  tm1637.point(POINT_ON);
  delay (500);
  TimeDisp[0] =  HeureDiz ;
  TimeDisp[1] =  HeureUnit;
  TimeDisp[2] =  MinutDiz;
  TimeDisp[3] =  MinutUnit;
  tm1637.display(TimeDisp);
  tm1637.point(POINT_OFF);
  delay (500);
  tm1637.display(TimeDisp);

  ValParle = digitalRead(Parlant);   // lecture de la touche
  Serial.println (ValParle);
  if (ValParle == HIGH) Parlante();
}

/////////////////////////////////////////////////
void Parlante()
{
  Serial.println ("Parlante 123456789");
  mp3_play (3300); //il est
  delay (650);

  switch (Heure) {

    case 0:
      mp3_play (2200); //zero
      delay (850);
      break;

    case 1:
      mp3_play (2201); //1
      delay (750);
      break;

    case 2:
      mp3_play (2202); //2
      delay (750);
      break;

    case 3:
      mp3_play (2203); //3
      delay (750);
      break;

    case 4:
      mp3_play (2204); //4
      delay (750);
      break;

    case 5:
      mp3_play (2205); //5
      delay (750);
      break;

    case 6:
      mp3_play (2206); //6
      delay (750);
      break;

    case 7:
      mp3_play (2207); //7
      delay (750);
      break;

    case 8:
      mp3_play (2208); //8
      delay (750);
      break;

    case 9:
      mp3_play (2209); //9
      delay (750);
      break;

    case 10:
      mp3_play (2210); //10
      delay (750);
      break;

    case 11:
      mp3_play (2211); //11
      delay (750);
      break;

    case 12:
      mp3_play (2212); //12
      delay (750);
      break;

    case 13:
      mp3_play (2213); //13
      delay (750);
      break;

    case 14:
      mp3_play (2214); //14
      delay (900);
      break;

    case 15:
      mp3_play (2215); //15
      delay (750);
      break;

    case 16:
      mp3_play (2216); // 16
      delay (750);
      break;

    case 17:
      mp3_play (2217); //10
      delay (850);
      break;

    case 18:
      mp3_play (2218); //10
      delay (850);
      break;

    case 19:
      mp3_play (2219); //10
      delay (850);
      break;

    case 20:
      mp3_play (2220); //20
      delay (750);
      break;

    case 21:
      mp3_play (2221); //21
      delay (950);
      break;

    case 22:
      mp3_play (2222); //22
      Serial.println ("22 heures 987654321");
      delay (1000);
      break;

    case 23:
      mp3_play (2223); //23
      delay (1000);
      break;
  }

  // mp3_play (3301); //  et
  delay (250);
  //////////////////////////////////////////////
  //////////////////////////////////////////////
  switch (Minutes) {

    case 0:
      mp3_play (1100); //zero
      delay (250);
      break;

    case 1:
      mp3_play (1101); //1
      delay (250);
      break;

    case 2:
      mp3_play (1102); //2
      delay (250);
      break;

    case 3:
      mp3_play (1103); //3
      delay (250);
      break;

    case 4:
      mp3_play (1104); //4
      delay (250);
      break;

    case 5:
      mp3_play (1105); //5
      delay (250);
      break;

    case 6:
      mp3_play (1106); //6
      delay (250);
      break;

    case 7:
      mp3_play (1107); //7
      delay (250);
      break;

    case 8:
      mp3_play (1108); //8
      delay (250);
      break;

    case 9:
      mp3_play (1109); //9
      delay (250);
      break;

    case 10:
      mp3_play (1110); //10
      delay (250);
      break;

    case 11:
      mp3_play (1111); //11
      delay (250);
      break;

    case 12:
      mp3_play (1112); //12
      delay (250);
      break;

    case 13:
      mp3_play (1113); //13
      delay (250);
      break;

    case 14:
      mp3_play (1114); //14
      delay (250);
      break;

    case 15:
      mp3_play (1115); //15
      delay (250);
      break;

    case 16:
      mp3_play (1116); // 16
      delay (250);
      break;

    case 17:
      mp3_play (1117); //10
      delay (250);
      break;

    case 18:
      mp3_play (1118); //10
      delay (250);
      break;

    case 19:
      mp3_play (1119); //10
      delay (250);
      break;

    case 20:
      mp3_play (1120); //20
      delay (250);
      break;

    case 21:
      mp3_play (1121); //21
      delay (250);
      break;

    case 22:
      mp3_play (1122); //22
      delay (250);
      break;

    case 23:
      mp3_play (1123); //23
      delay (250);
      break;

    case 24:
      mp3_play (1124); //24
      delay (250);
      break;

    case 25:
      mp3_play (1125); //25
      delay (250);
      break;

    case 26:
      mp3_play (1126); //26
      delay (250);
      break;

    case 27:
      mp3_play (1127); //27
      delay (250);
      break;

    case 28:
      mp3_play (1128); //28
      delay (250);
      break;

    case 29:
      mp3_play (1129); //29
      delay (250);
      break;

    case 30:
      mp3_play (1130); //30
      delay (250);
      break;

    case 31:
      mp3_play (1131); //31
      delay (300);
      break;

    case 32:
      mp3_play (1132); //32
      delay (350);
      break;

    case 33:
      mp3_play (1133); //33
      delay (350);
      break;

    case 34:
      mp3_play (1134); //34
      delay (350);
      break;

    case 35:
      mp3_play (1135); //35
      delay (350);
      break;

    case 36:
      mp3_play (1136); //36
      delay (250);
      break;

    case 37:
      mp3_play (1137); //37
      delay (350);
      break;

    case 38:
      mp3_play (1138); //38
      delay (350);
      break;

    case 39:
      mp3_play (1139); //39
      delay (350);

      break;

    case 40:
      mp3_play (1140); //40
      delay (750);
      break;

    case 41:
      mp3_play (1141); //41
      delay (750);
      break;

    case 42:
      mp3_play (1142); //42
      delay (750);
      break;

    case 43:
      mp3_play (1143); //43
      delay (750);

      break;

    case 44:
      mp3_play (1144); //44
      delay (750);
      break;

    case 45:
      mp3_play (1145); //45
      delay (750);
      break;

    case 46:
      mp3_play (1146); //46
      delay (750);
      break;

    case 47:
      mp3_play (1147); //47
      delay (750);
      break;

    case 48:
      mp3_play (1148); //48
      delay (750);
      break;

    case 49:
      mp3_play (1149); //49
      delay (750);
      break;

    case 50:
      mp3_play (1150); //50
      delay (600);
      break;

    case 51:
      mp3_play (1151); //51
      delay (600);
      break;

    case 52:
      mp3_play (1152); //52
      delay (600);
      break;

    case 53:
      mp3_play (1153); //53
      delay (600);

      break;

    case 54:
      mp3_play (1154); //54
      delay (600);
      break;

    case 55:
      mp3_play (1155); //55
      delay (600);
      break;

    case 56:
      mp3_play (1156); //56
      delay (600);
      break;

    case 57:
      mp3_play (1157); //57
      delay (600);
      break;

    case 58:
      mp3_play (1158); //58
      delay (600);
      break;

    case 59:
      mp3_play (1159); //59
      delay (600);
      break;
  }
}


